# wxRegEx Class Reference
[Data Structures]

`#include <wx/regex.h>`

## Detailed Description

wxRegEx represents a regular expression.

This class provides support for regular expressions matching and also replacement.

It is built on top of either the system library (if it has support for POSIX regular expressions - which is the case of the most modern Unices) or uses the built in Henry Spencer's library. Henry Spencer would appreciate being given credit in the documentation of software which uses his library, but that is not a requirement.

Regular expressions, as defined by POSIX, come in two flavours: extended and basic. The builtin library also adds a third flavour of expression advanced, which is not available when using the system library.

Unicode is fully supported only when using the builtin library. When using the system library in Unicode mode, the expressions and data are translated to the default 8-bit encoding before being passed to the library.

On platforms where a system library is available, the default is to use the builtin library for Unicode builds, and the system library otherwise. It is possible to use the other if preferred by selecting it when building the wxWidgets.

##

Library: wxBase

Category: Data Structures

Examples:

A bad example of processing some text containing email addresses (the example is bad because the real email addresses can have more complicated form than `user@host.net`):

        wxString text;
        ...
        wxRegEx reEmail = "([^@]+)@([[:alnum:].-_].)+([[:alnum:]]+)";
        if ( reEmail.Matches(text) )
        {
            wxString text = reEmail.GetMatch(email);
            wxString username = reEmail.GetMatch(email, 1);
            if ( reEmail.GetMatch(email, 3) == "com" ) // .com TLD?
            {
                ...
            }
        }

        // or we could do this to hide the email address
        size_t count = reEmail.ReplaceAll(text, "HIDDEN@\\2\\3");
        printf("text now contains %u hidden addresses", count);

## Public Member Functions
| wxRegEx ()
| Default constructor: use Compile() later.
| wxRegEx (const wxString &expr, int flags=wxRE_DEFAULT)
| Create and compile the regular expression, use IsValid() to test for compilation errors.
| ~wxRegEx ()
| Destructor.
bool | Compile (const wxString &pattern, int flags=wxRE_DEFAULT)
| Compile the string into regular expression, return true if ok or false if string has a syntax error.
bool | GetMatch (size_t *start, size_t *len, size_t index=0) const
| Get the start index and the length of the match of the expression (if index is 0) or a bracketed subexpression (index different from 0).
wxString | GetMatch (const wxString &text, size_t index=0) const
| Returns the part of string corresponding to the match where index is interpreted as above.
size_t | GetMatchCount () const
| Returns the size of the array of matches, i.e.
bool | IsValid () const
| Return true if this is a valid compiled regular expression, false otherwise.
bool | Matches (const wxString &text, int flags=0) const
| Matches the precompiled regular expression against the string text, returns true if matches and false otherwise.
int | Replace (wxString *text, const wxString &replacement, size_t maxMatches=0) const
| Replaces the current regular expression in the string pointed to by text, with the text in replacement and return number of matches replaced (maybe 0 if none found) or -1 on error.
int | ReplaceAll (wxString *text, const wxString &replacement) const
| Replace all occurrences: this is actually a synonym for Replace().
int | ReplaceFirst (wxString *text, const wxString &replacement) const
| Replace the first occurrence.
bool | Matches (const wxChar *text, int flags=0) const
| Matches the precompiled regular expression against the string text, returns true if matches and false otherwise.
bool | Matches (const wxChar *text, int flags, size_t len) const
| Matches the precompiled regular expression against the string text, returns true if matches and false otherwise.

List of all members.

## Constructor & Destructor Documentation

wxRegEx::wxRegEx | ( |  | ) |

Default constructor: use Compile() later.

wxRegEx::wxRegEx | ( | const wxString & | expr,
|  | int | flags = `wxRE_DEFAULT` |
| ) |  |  |

Create and compile the regular expression, use IsValid() to test for compilation errors.

As for the flags, please see wxRE_FLAGS.

wxRegEx::~wxRegEx | ( |  | ) |

Destructor.

It's not virtual, don't derive from this class.

## Member Function Documentation

bool wxRegEx::Compile | ( | const wxString & | pattern,
|  | int | flags = `wxRE_DEFAULT` |
| ) |  |  |

Compile the string into regular expression, return true if ok or false if string has a syntax error.

As for the flags, please see wxRE_FLAGS.

wxString wxRegEx::GetMatch | ( | const wxString & | text,
|  | size_t | index = `0` |
| ) |  |  | const

Returns the part of string corresponding to the match where index is interpreted as above.

Empty string is returned if match failed.

May only be called after successful call to Matches() and only if `wxRE_NOSUB` was not used in Compile().

bool wxRegEx::GetMatch | ( | size_t * | start,
|  | size_t * | len,
|  | size_t | index = `0` |
| ) |  |  | const

Get the start index and the length of the match of the expression (if index is 0) or a bracketed subexpression (index different from 0).

May only be called after successful call to Matches() and only if `wxRE_NOSUB` was not used in Compile().

Returns false if no match or if an error occurred.

size_t wxRegEx::GetMatchCount | ( |  | ) | const

Returns the size of the array of matches, i.e.

the number of bracketed subexpressions plus one for the expression itself, or 0 on error.

May only be called after successful call to Compile(). and only if `wxRE_NOSUB` was not used.

bool wxRegEx::IsValid | ( |  | ) | const

Return true if this is a valid compiled regular expression, false otherwise.

bool wxRegEx::Matches | ( | const wxString & | text,
|  | int | flags = `0` |
| ) |  |  | const

Matches the precompiled regular expression against the string text, returns true if matches and false otherwise.

Flags may be combination of `wxRE_NOTBOL` and `wxRE_NOTEOL`, see wxRE_NOT_FLAGS.

May only be called after successful call to Compile().

bool wxRegEx::Matches | ( | const wxChar * | text,
|  | int | flags,
|  | size_t | len |
| ) |  |  | const

Matches the precompiled regular expression against the string text, returns true if matches and false otherwise.

Flags may be combination of `wxRE_NOTBOL` and `wxRE_NOTEOL`, see wxRE_NOT_FLAGS.

Some regex libraries assume that the text given is null terminated, while others require the length be given as a separate parameter. Therefore for maximum portability assume that text cannot contain embedded nulls.

When the Matches(const wxChar *text, int flags = 0) form is used, a wxStrlen() will be done internally if the regex library requires the length. When using Matches() in a loop the Matches(text, flags, len) form can be used instead, making it possible to avoid a wxStrlen() inside the loop.

May only be called after successful call to Compile().

bool wxRegEx::Matches | ( | const wxChar * | text,
|  | int | flags = `0` |
| ) |  |  | const

Matches the precompiled regular expression against the string text, returns true if matches and false otherwise.

Flags may be combination of `wxRE_NOTBOL` and `wxRE_NOTEOL`, see wxRE_NOT_FLAGS.

Some regex libraries assume that the text given is null terminated, while others require the length be given as a separate parameter. Therefore for maximum portability assume that text cannot contain embedded nulls.

When the Matches(const wxChar *text, int flags = 0) form is used, a wxStrlen() will be done internally if the regex library requires the length. When using Matches() in a loop the Matches(text, flags, len) form can be used instead, making it possible to avoid a wxStrlen() inside the loop.

May only be called after successful call to Compile().

int wxRegEx::Replace | ( | wxString * | text,
|  | const wxString & | replacement,
|  | size_t | maxMatches = `0` |
| ) |  |  | const

Replaces the current regular expression in the string pointed to by text, with the text in replacement and return number of matches replaced (maybe 0 if none found) or -1 on error.

The replacement text may contain back references `\number` which will be replaced with the value of the corresponding subexpression in the pattern match. `\0` corresponds to the entire match and `&` is a synonym for it. Backslash may be used to quote itself or `&` character.

maxMatches may be used to limit the number of replacements made, setting it to 1, for example, will only replace first occurrence (if any) of the pattern in the text while default value of 0 means replace all.

int wxRegEx::ReplaceAll | ( | wxString * | text,
|  | const wxString & | replacement |
| ) |  |  | const

Replace all occurrences: this is actually a synonym for Replace().

See also:
  ReplaceFirst()

int wxRegEx::ReplaceFirst | ( | wxString * | text,
|  | const wxString & | replacement |
| ) |  |  | const

Replace the first occurrence.

|  | [ top ]